package cn.ibizlab.core.analysis.service;

import java.io.Serializable;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.util.Collection;
import java.math.BigInteger;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import org.springframework.scheduling.annotation.Async;
import com.alibaba.fastjson.JSONObject;
import org.springframework.cache.annotation.CacheEvict;

import cn.ibizlab.core.analysis.domain.DAMetric;
import cn.ibizlab.core.analysis.filter.DAMetricSearchContext;

import com.baomidou.mybatisplus.extension.service.IService;

/**
 * 实体[DAMetric] 服务对象接口
 */
public interface IDAMetricService extends IService<DAMetric> {

    boolean create(DAMetric et);
    void createBatch(List<DAMetric> list);
    boolean update(DAMetric et);
    void updateBatch(List<DAMetric> list);
    boolean remove(String key);
    void removeBatch(Collection<String> idList);
    DAMetric get(String key);
    DAMetric getDraft(DAMetric et);
    boolean checkKey(DAMetric et);
    boolean save(DAMetric et);
    void saveBatch(List<DAMetric> list);
    DAMetric syncRule(DAMetric et);
    boolean syncRuleBatch(List<DAMetric> etList);
    DAMetric testRule(DAMetric et);
    boolean testRuleBatch(List<DAMetric> etList);
    Page<DAMetric> searchDefault(DAMetricSearchContext context);
    List<DAMetric> selectByBuildId(String build_id);
    void removeByBuildId(String build_id);
    /**
     *自定义查询SQL
     * @param sql  select * from table where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return select * from table where id = '1'
     */
    List<JSONObject> select(String sql, Map param);
    /**
     *自定义SQL
     * @param sql  update table  set name ='test' where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return     update table  set name ='test' where id = '1'
     */
    boolean execute(String sql, Map param);

}


